package fibothreadoptimized;


/**
 * fibonacci: rekursiv mit 1 Warteschlange, mehreren Threads und komplexen Berechnungen zuerst
 * @author Michael Krauss, VGL Lauterecken
 *
 */
public class FiboMulticore {

	static long time;
	static int counter;//counts no of started and ended threads
	static final int limit = 50;//51;
	static final int noCores = 4;//2;
	
	public static void main(String[] args) {
		
		time = System.currentTimeMillis();
		
		FiboThreadManager ftm = new FiboThreadManager(noCores);
		
		//optimization 2a: start with highest fibonacci in queue
		for (int i = limit; i >= 0; i--)		
		{
			counter++;
			ftm.calculateFibo(i);
		}
		
		ftm.startCalculations();
						
	}
	
	
	public static void reduceCounter()
	{
		--counter;
		if(counter==0)
		{
			time = System.currentTimeMillis()-time;
			System.out.println("Calculating fibo from 0 to "+(limit)+" took "+time+" ms.");
		}
	}
	
}
