package fibothreadoptimized;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Queue;
import java.util.concurrent.ArrayBlockingQueue;

public class FiboThread extends Thread{
	
	private int threadNumber; //to identify, which thread this is	
	
	private FiboThreadManager ftm;
	
	public FiboThread(int threadNo, FiboThreadManager ftm)
	{
		threadNumber=threadNo;
		this.ftm = ftm;
	}
	
    public void run() {
    	
    	while(!ftm.isTaskListEmpty())
    	{
    		//take first element off list and process
    		long currentN = ftm.getNextNFromQueue();
    		long taskTimeStart = System.currentTimeMillis();
    		System.out.print("Thread: ["+threadNumber+"] fibo("+currentN+"): "+fibo(currentN));
    		//fibo(currentN);
    		taskTimeStart = System.currentTimeMillis() - taskTimeStart;
    		System.out.println(" | Calculation time: "+taskTimeStart+" ms.");
    		//System.out.println(taskTimeStart);
    		FiboMulticore.reduceCounter();
    	}
		
    }    

	public long fibo (long n)
	{
		if(n==0) return 0;
		if(n==1) return 1;
		
		return fibo(n-1)+fibo(n-2);
	}
 	
}
