package fibothreadoptimized;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Queue;

public class FiboThreadManager {

	ArrayList <FiboThread> threads=null;
		
	//the task list of n, the fibo should be calculated of	
	private LinkedList<Long> taskList;
	
	
	public FiboThreadManager(int noCores){
		threads = new ArrayList<FiboThread>();
		for(int i = 0; i< noCores; i++)
		{
			threads.add(new FiboThread(i, this));
		}
		taskList = new LinkedList<Long>();
	
	}
		
	//adds the requests to the processing queue 
	public void calculateFibo(long inputN)
	{		
		taskList.add(inputN);
	}	
	
	
	public void startCalculations()
	{
		for(int i = 0; i< threads.size(); i++)
		{
			threads.get(i).start();
		}
	}
	
	
	//methods accesssed by threads
	public synchronized boolean isTaskListEmpty()
	{
		return taskList.isEmpty();
	}
	
	public synchronized long getNextNFromQueue()
	{
		return taskList.removeFirst();
	}
	
}
