package fibo;

import java.math.BigDecimal;

/**
 * fibonacci: rekursiv, iterativ, moivre
 * @author Michael Krauss, VGL Lauterecken
 *
 */
public class Fibonacci {

	public static void main(String[] args) {
		int limit = 51;
		
		long time = System.currentTimeMillis();
		
		for(long i = 0; i < limit; i++)
		{
			//System.out.println("fibo("+i+"): "+fibo(i));
			//System.out.println("fiboiterativ("+i+"): "+fiboiterativ(i));
			System.out.println("fibomoivre("+i+"): "+fibomoivrebinet((int)i));
		}
		
		time = System.currentTimeMillis()-time;
		System.out.println("Calculating fibo from 0 to "+(limit-1)+" took "+time+" ms.");
	}

	public static long fibo (long n)
	{
		if(n==0) return 0;
		if(n==1) return 1;
		
		return fibo(n-1)+fibo(n-2);
	}
	
	
	public static long fiboiterativ (long n)
	{
		if(n==0) return 0;
		if(n==1) return 1;
		
		int nMinus1 = 1;
		int nMinus2 = 0;
		
		for(int i = 2; i < n; i++)
		{
			int zwerg = nMinus1+nMinus2;
			nMinus2=nMinus1;
			nMinus1=zwerg;
		}
		return nMinus1+nMinus2;
	}
	
	public static long fibomoivrebinet(int n)
	{		
		BigDecimal p1 = new BigDecimal(1/Math.sqrt(5.0));
		BigDecimal p2 = new BigDecimal((1+Math.sqrt(5.0))/2);
		p2 = p2.pow(n);		
		BigDecimal p3 = new BigDecimal((1-Math.sqrt(5.0))/2);
		p3 = p3.pow(n);

		BigDecimal res = p2.subtract(p3);
		res = res.multiply(p1);
		
		return res.longValue();				
	}
}
